%{
/*  shambler.config.c
    Part of the shambler, written by Jay D. Allen  jay@fork.com
    Jan 1997

    $Id: shambler.config.l,v 1.2 1999/04/22 05:56:51 jay Exp jay $
*/
#include "shambler.h"
 
%}

%%


\n	/* Keep going */;

#.*	/* Ignore Comments */;

[\t ]+	/* Ignore whitespace */;

^[a-zA-Z0123456789]+	/* return the text */ return(1);

%%

read_config(config_name)
char *config_name;
{
int conf_fd,index;
char *list;
char *uid_tester[20];
int skip;
long x;
struct passwd *passwd_entry;
static char rcsid[] = "$Id: shambler.config.l,v 1.2 1999/04/22 05:56:51 jay Exp jay $";

  /* arranges for lexer to use config file for input */
  yyin = fopen(config_name,"r");
   index=0;
   while(yylex() != NULL){
     skip=0;
     x=-1;
     x=atol(yytext);
     if(x != NULL && x > 0) {
        if(mydebug){
        printf("possible UID: %d\n",x);
        }
        valid_uids[index]=x;
        index++;

        } else {
/*            printf("searching for user: %s\n",yytext); */
     if(((struct passwd *) passwd_entry=getpwnam(yytext)) == NULL ){
        if(mydebug){
         printf("no such user, or error: %s\n",yytext);
         } } else {
/*          printf("will add: %d\n",passwd_entry->pw_uid);*/
          valid_uids[index]=passwd_entry->pw_uid;
          index++;
         }
        }
      endpwent(); /* needed in linux to remove /etc/.pwd.lock? */
      if(mydebug){
        }
     }
  if(index == 0) { 
       return(index) ;
      } else {
       return(index-1);
      }
}
